(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@fortawesome/react-fontawesome'), require('lemo-object'), require('prop-types'), require('reactstrap'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', '@fortawesome/react-fontawesome', 'lemo-object', 'prop-types', 'reactstrap', 'react'], factory) :
  (factory((global.LemoForm = {}),global.FontAwesomeIcon,global.LemoObject,global.PropTypes,global.Reactstrap,global.React));
}(this, (function (exports,reactFontawesome,lemoObject,PropTypes,reactstrap,React) { 'use strict';

  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  var FieldAddonAppend =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FieldAddonAppend, _React$Component);

    function FieldAddonAppend() {
      _classCallCheck(this, FieldAddonAppend);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldAddonAppend).apply(this, arguments));
    }

    _createClass(FieldAddonAppend, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            icon = _this$props.icon,
            text = _this$props.text;

        if (!icon && !text) {
          return "";
        }

        var content = text;

        if (icon) {
          content = React.createElement(reactFontawesome.FontAwesomeIcon, {
            icon: icon,
            fixedWidth: true
          });
        }

        return React.createElement(reactstrap.InputGroupAddon, {
          addonType: "append"
        }, React.createElement(reactstrap.InputGroupText, null, content));
      }
    }]);

    return FieldAddonAppend;
  }(React.Component);

  FieldAddonAppend.propTypes = {
    icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    text: PropTypes.string
  };

  var FieldAddonPrepend =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FieldAddonPrepend, _React$Component);

    function FieldAddonPrepend() {
      _classCallCheck(this, FieldAddonPrepend);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldAddonPrepend).apply(this, arguments));
    }

    _createClass(FieldAddonPrepend, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            icon = _this$props.icon,
            text = _this$props.text;

        if (!icon && !text) {
          return "";
        }

        var content = text;

        if (icon) {
          content = React.createElement(reactFontawesome.FontAwesomeIcon, {
            icon: icon,
            fixedWidth: true
          });
        }

        return React.createElement(reactstrap.InputGroupAddon, {
          addonType: "prepend"
        }, React.createElement(reactstrap.InputGroupText, null, content));
      }
    }]);

    return FieldAddonPrepend;
  }(React.Component);

  FieldAddonPrepend.propTypes = {
    icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    text: PropTypes.string
  };

  var FieldFeedback =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FieldFeedback, _React$Component);

    function FieldFeedback() {
      _classCallCheck(this, FieldFeedback);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldFeedback).apply(this, arguments));
    }

    _createClass(FieldFeedback, [{
      key: "render",
      value: function render() {
        var error = this.props.error;

        if (!error) {
          return "";
        }

        return React.createElement(reactstrap.FormFeedback, null, error);
      }
    }]);

    return FieldFeedback;
  }(React.Component);

  FieldFeedback.propTypes = {
    error: PropTypes.string
  };

  var defaultProps = {
    required: false
  };
  var propTypes = {
    name: PropTypes.string,
    required: PropTypes.bool,
    text: PropTypes.string
  };

  var FieldLabel =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FieldLabel, _React$Component);

    function FieldLabel() {
      _classCallCheck(this, FieldLabel);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldLabel).apply(this, arguments));
    }

    _createClass(FieldLabel, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            name = _this$props.name,
            required = _this$props.required,
            text = _this$props.text;

        if (!text) {
          return "";
        }

        if (!required) {
          return React.createElement(reactstrap.Label, {
            for: name
          }, text);
        }

        return React.createElement(reactstrap.Label, {
          for: name
        }, text, " ", React.createElement("em", {
          className: "required"
        }, "*"));
      }
    }]);

    return FieldLabel;
  }(React.Component);

  FieldLabel.defaultProps = defaultProps;
  FieldLabel.propTypes = propTypes;

  var FieldText =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FieldText, _React$Component);

    function FieldText() {
      _classCallCheck(this, FieldText);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldText).apply(this, arguments));
    }

    _createClass(FieldText, [{
      key: "render",
      value: function render() {
        var text = this.props.text;

        if (!text) {
          return "";
        }

        return React.createElement(reactstrap.FormText, null, text);
      }
    }]);

    return FieldText;
  }(React.Component);

  FieldText.propTypes = {
    text: PropTypes.string
  };

  var FormContext = React.createContext();

  var withFormApi = function withFormApi(Component) {
    return React.forwardRef(function (props, ref) {
      return React.createElement(FormContext.Consumer, null, function (_ref) {
        var formApi = _ref.formApi;
        return React.createElement(Component, _extends({
          formApi: formApi,
          ref: ref
        }, props));
      });
    });
  };

  var Field =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Field, _React$Component);

    function Field(props) {
      var _this;

      _classCallCheck(this, Field);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Field).call(this, props));
      _this.state = {
        disabled: props.disabled,
        error: props.formApi.getError(props.name),
        options: props.options,
        required: props.required,
        validatorsEnabled: props.validatorsEnabled,
        value: props.formApi.getValue(props.name),
        visible: props.visible
      };
      _this.handleBlur = _this.handleBlur.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      return _this;
    }

    _createClass(Field, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var formApi = this.props.formApi;
        formApi.setField(this.props.name, this);
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        var formApi = this.props.formApi;
        formApi.removeField(this.props.name);
      }
    }, {
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.disabled !== this.props.disabled) {
          this.setState({
            disabled: nextProps.disabled
          });
        }

        if (nextProps.error !== this.props.error) {
          this.setState({
            error: nextProps.error
          });
        }

        if (nextProps.options !== this.props.options) {
          this.setState({
            options: nextProps.options
          });
        }

        if (nextProps.required !== this.props.required) {
          this.setState({
            required: nextProps.required
          });
        }

        if (nextProps.validatorsEnabled !== this.props.validatorsEnabled) {
          this.setState({
            validatorsEnabled: nextProps.validatorsEnabled
          });
        }

        if (nextProps.value !== this.props.value) {
          this.setState({
            value: nextProps.value
          });
        }

        if (nextProps.visible !== this.props.visible) {
          this.setState({
            visible: nextProps.visible
          });
        }
      }
    }, {
      key: "handleBlur",
      value: function handleBlur(e) {
        var formApi = this.props.formApi;

        if ("file" === this.props.type) {
          formApi.setValue(e.target.name + "Metadata", e.target.files[0]);
        }

        formApi.handleOnBlur(e.target.name, e.target.value);
      }
    }, {
      key: "handleChange",
      value: function handleChange(e) {
        var formApi = this.props.formApi;

        if ("file" === this.props.type) {
          formApi.setValue(e.target.name + "Metadata", e.target.files[0]);
        }

        formApi.handleOnChange(e.target.name, e.target.value);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            addonAppendIcon = _this$props.addonAppendIcon,
            addonAppendText = _this$props.addonAppendText,
            addonPrependIcon = _this$props.addonPrependIcon,
            addonPrependText = _this$props.addonPrependText,
            disabledIfEmptyOptions = _this$props.disabledIfEmptyOptions,
            label = _this$props.label,
            name = _this$props.name,
            optionsEmpty = _this$props.optionsEmpty,
            text = _this$props.text,
            type = _this$props.type;
        var _this$state = this.state,
            error = _this$state.error,
            options = _this$state.options,
            required = _this$state.required,
            visible = _this$state.visible;
        var _this$state2 = this.state,
            disabled = _this$state2.disabled,
            value = _this$state2.value;

        if (!visible) {
          return "";
        }

        var field = null;

        switch (type) {
          case "select":
            if (true === disabledIfEmptyOptions && 0 === options.length) {
              disabled = true;
            }

            if (0 === options.length) {
              value = "";
            }

            field = React.createElement(reactstrap.Input, {
              disabled: disabled,
              invalid: !!error,
              name: name,
              onBlur: this.handleBlur,
              onChange: this.handleChange,
              required: required,
              type: type,
              value: value || ""
            }, optionsEmpty && React.createElement("option", {
              value: ""
            }, "-"), this.renderOptions());
            break;

          default:
            field = React.createElement(reactstrap.Input, {
              disabled: disabled,
              invalid: !!error,
              name: name,
              onBlur: this.handleBlur,
              onChange: this.handleChange,
              required: required,
              type: type,
              value: !value && value !== 0 ? "" : value
            });
        }

        return React.createElement(reactstrap.FormGroup, null, React.createElement(FieldLabel, {
          name: name,
          required: required,
          text: label
        }), React.createElement(reactstrap.InputGroup, null, React.createElement(FieldAddonPrepend, {
          icon: addonPrependIcon,
          text: addonPrependText
        }), field, React.createElement(FieldAddonAppend, {
          icon: addonAppendIcon,
          text: addonAppendText
        }), React.createElement(FieldFeedback, {
          error: error
        })), React.createElement(FieldText, {
          text: text
        }));
      }
    }, {
      key: "renderOptions",
      value: function renderOptions() {
        var _this$props2 = this.props,
            options = _this$props2.options,
            optionsKey = _this$props2.optionsKey,
            optionsValue = _this$props2.optionsValue;
        return options.map(function (option) {
          return React.createElement("option", {
            key: option[optionsKey],
            value: option[optionsKey]
          }, option[optionsValue]);
        });
      }
    }]);

    return Field;
  }(React.Component);

  Field.defaultProps = {
    addonAppendIcon: null,
    addonAppendText: null,
    addonPrependIcon: null,
    addonPrependText: null,
    disabled: false,
    disabledIfEmptyOptions: true,
    disabledIfInvalid: [],
    options: [],
    optionsEmpty: true,
    required: false,
    requiredIfNotEmpty: [],
    text: null,
    touched: false,
    type: "text",
    validateIfChange: [],
    validateOnChange: true,
    validators: [],
    validatorsEnabled: true,
    value: "",
    visible: true
  };
  Field.propTypes = {
    addonAppendIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    addonAppendText: PropTypes.string,
    addonPrependIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    addonPrependText: PropTypes.string,
    disabled: PropTypes.bool,
    disabledIfEmptyOptions: PropTypes.bool,
    disabledIfInvalid: PropTypes.array,
    error: PropTypes.string,
    label: PropTypes.string,
    name: PropTypes.string.isRequired,
    onBlur: PropTypes.func,
    onBlurIfValid: PropTypes.func,
    onChange: PropTypes.func,
    onChangeIfValid: PropTypes.func,
    onNormalize: PropTypes.func,
    onValidate: PropTypes.func,
    options: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
    optionsEmpty: PropTypes.bool,
    optionsKey: PropTypes.string,
    optionsValue: PropTypes.string,
    required: PropTypes.bool,
    requiredIfNotEmpty: PropTypes.array,
    ref: PropTypes.func,
    text: PropTypes.string,
    touched: PropTypes.bool,
    type: PropTypes.string,
    validateIfChange: PropTypes.array,
    validateOnChange: PropTypes.bool,
    validators: PropTypes.array,
    validatorsEnabled: PropTypes.bool,
    visible: PropTypes.bool,
    value: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
  };
  var Field$1 = withFormApi(Field);

  var Form =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Form, _React$Component);

    function Form(props) {
      var _this;

      _classCallCheck(this, Form);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Form).call(this, props));
      _this.state = {
        isHighlightingErrors: false,
        isSubmitting: false
      };
      _this.errors = new lemoObject.DataMap();
      _this.fields = new Map();
      _this.fieldsDisabledIfInvalid = new Map();
      _this.fieldsRequiredIfNotEmpty = new Map();
      _this.fieldsTriggerDisabled = new Map();
      _this.touched = new lemoObject.DataMap();
      _this.values = new lemoObject.DataMap(props.values);
      _this.getError = _this.getError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.getErrors = _this.getErrors.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.getField = _this.getField.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.getTouched = _this.getTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.getValue = _this.getValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.getValues = _this.getValues.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.hasError = _this.hasError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.hasField = _this.hasField.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.hasTouched = _this.hasTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.hasValue = _this.hasValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleChangeValue = _this.handleChangeValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleValidate = _this.handleValidate.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleOnBlur = _this.handleOnBlur.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleOnChange = _this.handleOnChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.handleOnSubmit = _this.handleOnSubmit.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.removeError = _this.removeError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.removeField = _this.removeField.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.removeTouched = _this.removeTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.removeValue = _this.removeValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.setError = _this.setError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.setField = _this.setField.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.setTouched = _this.setTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.setValue = _this.setValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      return _this;
    }

    _createClass(Form, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.values !== this.props.values) {
          this.values = new lemoObject.DataMap(nextProps.values);

          if (0 === Object.keys(nextProps.values).length) {
            this.fields.forEach(function (field) {
              field.setState({
                error: null,
                touched: false,
                value: ""
              });
            });
          } else {
            this.fields.forEach(function (field) {
              var fieldName = field.props.name;

              if (nextProps.values.hasOwnProperty(fieldName)) {
                field.setState({
                  value: nextProps.values[fieldName]
                });
              }
            });
          }
        }
      }
    }, {
      key: "getError",
      value: function getError(name) {
        if (!this.errors.has(name)) {
          return null;
        }

        return this.errors.get(name);
      }
    }, {
      key: "getErrors",
      value: function getErrors() {
        return this.errors.object;
      }
    }, {
      key: "getField",
      value: function getField(name) {
        if (!this.fields.has(name)) {
          return null;
        }

        return this.fields.get(name);
      }
    }, {
      key: "getTouched",
      value: function getTouched(name) {
        if (!this.touched.has(name)) {
          return null;
        }

        return this.touched.get(name);
      }
    }, {
      key: "getValue",
      value: function getValue(name) {
        if (!this.values.has(name)) {
          return null;
        }

        return this.values.get(name);
      }
    }, {
      key: "getValues",
      value: function getValues() {
        return this.values.object;
      }
    }, {
      key: "hasError",
      value: function hasError(name) {
        return this.errors.has(name);
      }
    }, {
      key: "hasField",
      value: function hasField(name) {
        return this.fields.has(name);
      }
    }, {
      key: "hasTouched",
      value: function hasTouched(name) {
        return this.touched.has(name);
      }
    }, {
      key: "hasValue",
      value: function hasValue(name) {
        return this.values.has(name);
      }
    }, {
      key: "removeError",
      value: function removeError(name) {
        this.errors.delete(name);
      }
    }, {
      key: "removeField",
      value: function removeField(name) {
        this.fields.delete(name);
      }
    }, {
      key: "removeTouched",
      value: function removeTouched(name) {
        this.touched.delete(name);
      }
    }, {
      key: "removeValue",
      value: function removeValue(name) {
        this.values.delete(name);
      }
    }, {
      key: "setError",
      value: function setError(name, error) {
        this.handleChangeError(name, error);
      }
    }, {
      key: "setField",
      value: function setField(name, field) {
        var _this2 = this;

        this.fields.set(name, field); // Disabled if not valid

        if (field.props.disabledIfInvalid.length > 0) {
          this.fieldsDisabledIfInvalid.set(name, field.props.disabledIfInvalid);
          field.props.disabledIfInvalid.forEach(function (fieldToCheck) {
            if (!_this2.fieldsTriggerDisabled.has(fieldToCheck)) {
              _this2.fieldsTriggerDisabled.set(fieldToCheck, []);
            }

            _this2.fieldsTriggerDisabled.get(fieldToCheck).push(name);
          });
        } // Required if not empty


        if (field.props.requiredIfNotEmpty.length > 0) {
          this.fieldsRequiredIfNotEmpty.set(name, field.props.requiredIfNotEmpty);
        } // Default value


        if (this.values.has(name)) {
          field.setState({
            value: this.values.get(name)
          });
        }
      }
    }, {
      key: "setTouched",
      value: function setTouched(name, value) {
        this.touched.set(name, value);
      }
    }, {
      key: "setValue",
      value: function setValue(name, value) {
        this.handleChangeValue(name, value);
      }
    }, {
      key: "handleOnBlur",
      value: function handleOnBlur(name, value) {
        var field = this.fields.get(name);
        this.handleChangeValue(name, value); // Field - On blur

        if (field.props.hasOwnProperty("onBlur") && typeof field.props.onBlur === "function") {
          field.props.onBlur(this.handleApi);
        } // Field - On blur if valid


        if (field.props.hasOwnProperty("onBlurIfValid") && typeof field.props.onBlurIfValid === "function" && !this.errors.get(name)) {
          field.props.onBlurIfValid(this.handleApi);
        } // Form - On blur


        if (this.props.hasOwnProperty("onBlur") && typeof this.props.onBlur === "function") {
          this.props.onBlur(this.handleApi);
        }
      }
    }, {
      key: "handleOnChange",
      value: function handleOnChange(name, value) {
        var field = this.fields.get(name);
        this.handleChangeValue(name, value); // Field - On change

        if (field.props.hasOwnProperty("onChange") && typeof field.props.onChange === "function") {
          field.props.onChange(this.handleApi);
        } // Field - On change if valid


        if (field.props.hasOwnProperty("onChangeIfValid") && typeof field.props.onChangeIfValid === "function" && !this.errors.get(name)) {
          field.props.onChangeIfValid(this.handleApi);
        } // Form - On change


        if (this.props.hasOwnProperty("onChange") && typeof this.props.onChange === "function") {
          this.props.onChange(this.handleApi);
        }
      }
    }, {
      key: "handleOnSubmit",
      value: function () {
        var _handleOnSubmit = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(e) {
          var _this3 = this;

          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  e.preventDefault(e);
                  _context.next = 3;
                  return this.setState({
                    isSubmitting: true
                  });

                case 3:
                  _context.next = 5;
                  return this.fields.forEach(function (field, name) {
                    _this3.handleValidate(name);
                  });

                case 5:
                  if (!this.errors.empty()) {
                    _context.next = 9;
                    break;
                  }

                  _context.next = 8;
                  return this.props.onSubmit(this.handleApi);

                case 8:
                  return _context.abrupt("return");

                case 9:
                  _context.next = 11;
                  return this.setState({
                    isHighlightingErrors: true,
                    isSubmitting: false
                  });

                case 11:
                  setTimeout(function () {
                    this.setState({
                      isHighlightingErrors: false
                    });
                  }.bind(this), 500);
                  return _context.abrupt("return", this);

                case 13:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function handleOnSubmit(_x) {
          return _handleOnSubmit.apply(this, arguments);
        };
      }()
    }, {
      key: "handleChangeError",
      value: function handleChangeError(name, error) {
        error = error || null;

        if (!error) {
          this.errors.delete(name);
        } else {
          this.errors.set(name, error);
        }

        if (this.fields.has(name)) {
          this.fields.get(name).setState({
            error: error
          });
        }
      }
    }, {
      key: "handleChangeValue",
      value: function () {
        var _handleChangeValue = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(name, value) {
          var _this4 = this;

          var field, namesToCheck, isRequired;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  value = value || null;

                  if (this.fields.has(name)) {
                    _context2.next = 4;
                    break;
                  }

                  this.values.set(name, value);
                  return _context2.abrupt("return", this);

                case 4:
                  field = this.fields.get(name); // On normalize

                  if (field.props.hasOwnProperty("onNormalize") && typeof field.props.onNormalize === "function") {
                    value = field.props.onNormalize(value, field.state.value);
                  } // Value is the same


                  if (!(value === field.state.value)) {
                    _context2.next = 8;
                    break;
                  }

                  return _context2.abrupt("return", false);

                case 8:
                  // Set value
                  this.values.set(name, value); // Set touched

                  this.touched.set(name, true); // Validation

                  if (true === field.props.validateOnChange) {
                    this.handleValidate(name);
                  } // Disabled if not valid


                  if (!this.fieldsTriggerDisabled.has(name)) {
                    _context2.next = 14;
                    break;
                  }

                  _context2.next = 14;
                  return this.fieldsTriggerDisabled.get(name).forEach(function (nameToDisable) {
                    if (_this4.fieldsDisabledIfInvalid.has(nameToDisable)) {
                      var isValid = true;

                      _this4.fieldsDisabledIfInvalid.get(nameToDisable).forEach(function (nameToCheckValue) {
                        if (true === isValid && _this4.errors.has(nameToCheckValue)) {
                          isValid = false;
                        }
                      });

                      if (true === isValid) {
                        _this4.fields.get(nameToDisable).setState({
                          disabled: false
                        });
                      } else {
                        _this4.errors.delete(nameToDisable);

                        _this4.values.set(nameToDisable, "");

                        _this4.fields.get(nameToDisable).setState({
                          error: null,
                          disabled: true,
                          options: [],
                          value: ""
                        });
                      }
                    }
                  });

                case 14:
                  if (!this.fieldsRequiredIfNotEmpty.has(name)) {
                    _context2.next = 20;
                    break;
                  }

                  namesToCheck = this.fieldsRequiredIfNotEmpty.get(name); // Is some field filled?

                  isRequired = false;
                  namesToCheck.forEach(function (nameToCheck) {
                    if (false === isRequired) {
                      if (!!_this4.values.get(nameToCheck)) {
                        isRequired = true;
                      }
                    }
                  }); // Change state of fields

                  _context2.next = 20;
                  return this.fieldsRequiredIfNotEmpty.forEach(function (field, nameToChange) {
                    if (_this4.fields.has(nameToChange)) {
                      var fieldToChange = _this4.fields.get(nameToChange);

                      if (fieldToChange.state.required !== isRequired) {
                        if (true === isRequired) {
                          fieldToChange.setState({
                            required: isRequired,
                            validatorsEnabled: isRequired
                          });
                        } else {
                          fieldToChange.setState({
                            error: null,
                            required: isRequired,
                            validatorsEnabled: isRequired
                          });
                        }
                      }
                    }
                  });

                case 20:
                  // Update field state
                  field.setState({
                    touched: this.touched.get(name),
                    value: this.values.get(name)
                  });
                  return _context2.abrupt("return", this);

                case 22:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        return function handleChangeValue(_x2, _x3) {
          return _handleChangeValue.apply(this, arguments);
        };
      }()
    }, {
      key: "handleValidate",
      value: function handleValidate(name) {
        var _this5 = this;

        var nameToSkip = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var isRecursive = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var error = null;
        var field = this.fields.get(name);
        var value = this.values.get(name) || '';

        if (false === field.state.validatorsEnabled) {
          return null;
        }

        if (field.state.visible) {
          field.props.validators.forEach(function (validator) {
            if (null === error) {
              error = validator.validate(value.trim(), _this5.values);
              field.props.validateIfChange.forEach(function (nameToValidate) {
                if (nameToValidate !== nameToSkip && _this5.fields.has(nameToValidate)) {
                  if (_this5.touched.has(nameToValidate)) {
                    _this5.handleValidate(nameToValidate, name, true);
                  }
                }
              });
            }
          });
        }

        this.handleChangeError(name, error);

        if (false === isRecursive && this.props.hasOwnProperty("onValidate") && typeof this.props.onValidate === "function") {
          this.props.onValidate(this.handleApi);
        }

        return this;
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            children = _this$props.children,
            component = _this$props.component,
            render = _this$props.render,
            noValidate = _this$props.noValidate,
            onBlur = _this$props.onBlur,
            onChange = _this$props.onChange,
            onSubmit = _this$props.onSubmit,
            onValidate = _this$props.onValidate,
            values = _this$props.values,
            rest = _objectWithoutProperties(_this$props, ["children", "component", "render", "noValidate", "onBlur", "onChange", "onSubmit", "onValidate", "values"]);

        return React.createElement(FormContext.Provider, {
          value: this.formContext
        }, React.createElement(reactstrap.Form, _extends({}, rest, {
          className: this.formClassName,
          noValidate: noValidate,
          onChange: this.onChange,
          onSubmit: this.handleOnSubmit
        }), this.content));
      }
    }, {
      key: "formClassName",
      get: function get() {
        return this.state.isHighlightingErrors ? "invalid-highlight" : null;
      }
    }, {
      key: "handleApi",
      get: function get() {
        return {
          getError: this.getError,
          getErrors: this.getErrors,
          getTouched: this.getTouched,
          getValue: this.getValue,
          getValues: this.getValues,
          hasError: this.hasError,
          hasTouched: this.hasTouched,
          hasValue: this.hasValue,
          removeError: this.removeError,
          removeTouched: this.removeTouched,
          removeValue: this.removeValue,
          setError: this.setError,
          setTouched: this.setTouched,
          setValue: this.setValue
        };
      }
    }, {
      key: "formContext",
      get: function get() {
        return {
          formApi: {
            getError: this.getError,
            getErrors: this.getErrors,
            getField: this.getField,
            getTouched: this.getTouched,
            getValue: this.getValue,
            getValues: this.getValues,
            hasError: this.hasError,
            hasField: this.hasField,
            hasTouched: this.hasTouched,
            hasValue: this.hasValue,
            isHighlightingErrors: this.state.isHighlightingErrors,
            isSubmitting: this.state.isSubmitting,
            handleOnBlur: this.handleOnBlur,
            handleOnChange: this.handleOnChange,
            removeError: this.removeError,
            removeField: this.removeField,
            removeTouched: this.removeTouched,
            removeValue: this.removeValue,
            setError: this.setError,
            setField: this.setField,
            setTouched: this.setTouched,
            setValue: this.setValue
          }
        };
      }
    }, {
      key: "content",
      get: function get() {
        var _this$props2 = this.props,
            children = _this$props2.children,
            component = _this$props2.component,
            render = _this$props2.render;
        var props = this.formContext;

        if (component) {
          return React.createElement(component, props, children);
        }

        if (render) {
          return render(props);
        }

        if (typeof children === "function") {
          return children(props);
        }

        return children;
      }
    }]);

    return Form;
  }(React.Component);

  Form.defaultProps = {
    noValidate: true,
    onChange: null,
    values: {}
  };
  Form.propTypes = {
    noValidate: PropTypes.bool,
    onBlur: PropTypes.func,
    onChange: PropTypes.func,
    onSubmit: PropTypes.func.isRequired,
    onValidate: PropTypes.func,
    values: PropTypes.object
  };

  var buildFieldApi = function buildFieldApi(formApi, name) {
    return {
      set: function set(field) {
        return formApi.set(name, field);
      },
      remove: function remove() {
        return formApi.remove(name);
      },
      getValue: function getValue() {
        return formApi.getValue(name);
      },
      setValue: function setValue(value) {
        return formApi.setValue(name, value);
      },
      getTouched: function getTouched() {
        return formApi.getTouched(name);
      },
      setTouched: function setTouched(value) {
        return formApi.setTouched(name, value);
      },
      getError: function getError() {
        return formApi.getError(name);
      },
      setError: function setError(value) {
        return formApi.setError(name, value);
      }
    };
  };

  var buildFieldState = function buildFieldState(formApi, name) {
    return {
      disabled: false,
      error: formApi.getError(name),
      touched: formApi.getTouched(name),
      required: false,
      visible: true,
      value: formApi.getValue(name)
    };
  };

  var withField = function withField(Component) {
    return withFormApi(
    /*#__PURE__*/
    function (_React$PureComponent) {
      _inherits(_class, _React$PureComponent);

      function _class(props) {
        var _this;

        _classCallCheck(this, _class);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(_class).call(this, props));
        var formApi = props.formApi,
            name = props.name;
        _this.fieldApi = buildFieldApi(formApi, name);
        _this.fieldState = buildFieldState(formApi, name); // Rebuild state when name changes

        _this.fieldStateUpdate = function () {
          console.log(_assertThisInitialized(_assertThisInitialized(_this)));

          _this.setState(buildFieldState(formApi, name));
        };

        return _this;
      }

      _createClass(_class, [{
        key: "render",
        value: function render() {
          var rest = _extends({}, this.props);

          return React.createElement(Component, _extends({
            fieldApi: this.fieldApi,
            fieldState: this.fieldState,
            fieldStateUpdate: this.fieldStateUpdate
          }, rest));
        }
      }]);

      return _class;
    }(React.PureComponent));
  };

  var withFieldApi = function withFieldApi(field) {
    return function (Component) {
      return withFormApi(function (_ref) {
        var formApi = _ref.formApi,
            props = _objectWithoutProperties(_ref, ["formApi"]);

        return React.createElement(Component, _extends({
          fieldApi: buildFieldApi(formApi, field)
        }, props));
      });
    };
  };

  var withFieldState = function withFieldState(field) {
    return function (Component) {
      return withFormApi(function (_ref2) {
        var formApi = _ref2.formApi,
            props = _objectWithoutProperties(_ref2, ["formApi"]);

        return React.createElement(Component, _extends({
          fieldState: buildFieldState(formApi, field)
        }, props));
      });
    };
  };

  exports.Field = Field$1;
  exports.FieldAddonAppend = FieldAddonAppend;
  exports.FieldAddonPrepend = FieldAddonPrepend;
  exports.FieldFeedback = FieldFeedback;
  exports.FieldLabel = FieldLabel;
  exports.FieldText = FieldText;
  exports.Form = Form;
  exports.FormContext = FormContext;
  exports.withField = withField;
  exports.withFieldApi = withFieldApi;
  exports.withFieldState = withFieldState;
  exports.withFormApi = withFormApi;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=lemo-form.umd.js.map
